#include <stdio.h>
#include <stdlib.h>

struct Rectangle {
    float x, y, w, h;
};

float calculer_aire(struct Rectangle r) {
    return r.w * r.h;
}

float min(float a, float b) {
    if (a>b) {
        return b;
    } else {
        return a;
    }
}

float max(float a, float b) {
    if (a>b) {
        return a;
    } else {
        return b;
    }
}


struct Rectangle intersection(struct Rectangle r1, struct Rectangle r2) {
    float x_left, y_top, x_right, y_bottom;
    struct Rectangle result;

    x_left = max(r1.x,r2.x);
    y_top = max(r1.y,r2.y);
    x_right = min(r1.x + r1.w,r2.x + r2.w);
    y_bottom = min(r1.y + r1.h,r2.y + r2.h);

    result.x = x_left;
    result.y = y_top;

    if (x_right >= x_left) {
        result.w = x_right - x_left;
    } else {
        result.w = -1;
    }

    if (y_bottom >= y_top) {
        result.h = y_bottom - y_top;
    } else {
        result.h = 0;
    }

    return result;
}

struct Rectangle* creer_tableau_rectangles(int argc, char* argv[], int* n) {
    *n = (argc - 1) / 4;
    struct Rectangle* rectangles = malloc(*n * sizeof(struct Rectangle));
    
    for (int i = 0; i < *n; i++) {
        rectangles[i].x = atof(argv[i*4 + 1]);
        rectangles[i].y = atof(argv[i*4 + 2]);
        rectangles[i].w = atof(argv[i*4 + 3]);
        rectangles[i].h = atof(argv[i*4 + 4]);
    }
    
    return rectangles;
}

struct Rectangle* reduction(struct Rectangle* rectangles, int n) {
    struct Rectangle* rect_red = malloc(n * sizeof(struct Rectangle));
    
    for (int i = 1; i < n; i++) {
        rect_red[i] = intersection(rectangles[0], rectangles[i]);
    }
    
    rect_red[0] = rectangles[0]; 
    
    return rect_red;
}

void affichage(struct Rectangle* rectangles, int n) {
    for (int i = 1; i < n; i++) {
        printf("Rectangle %d : %.2f\n", i, calculer_aire(rectangles[i]));
    }
}

int main(int argc, char* argv[]) {
    int n;
    struct Rectangle* rectangles = creer_tableau_rectangles(argc, argv, &n);

    // Aires des rectangles originaux
    affichage(rectangles, n);

    struct Rectangle* rect_red = reduction(rectangles, n);

    // Aires des rectangles réduits
    affichage(rect_red, n);

    free(rectangles);
    free(rect_red);

    return 0;
}